/**
 * Title :        XLogo
 * Description :  XLogo is an interpreter for the Logo 
 * 						programming language
 * @author Loïc Le Coq
 */package xlogo;
import javax.swing.JMenuItem;
import javax.swing.text.JTextComponent;
import javax.swing.text.BadLocationException;
import javax.swing.JPopupMenu;
import java.awt.event.*;
public class Popup extends JPopupMenu implements ActionListener {
	private static final long serialVersionUID = 1L;
	private String[] car=new String[12];
	private JMenuItem[] jpopcar=new JMenuItem[12];
	private JMenuItem jpopcopier = new JMenuItem();
	private JMenuItem jpopcoller = new JMenuItem();
	private JMenuItem jpopcouper = new JMenuItem();
	private JPopupMenu.Separator separ=new JPopupMenu.Separator();
	JTextComponent jt=null;
	
	public Popup(ActionListener menulistener,JTextComponent jt){
		this.jt=jt;
		car[0]="\u0109";
		car[1]="\u011d";
		car[2]="\u0125";
		car[3]="\u0135";
		car[4]="\u015d";
		car[5]="\u016d";
		car[6]="\u0108";
		car[7]="\u011c";
		car[8]="\u0124";
		car[9]="\u0134";
		car[10]="\u015c";
		car[11]="\u016c";
		for(int i=0;i<car.length;i++) {
			jpopcar[i]=new JMenuItem(car[i]);
			jpopcar[i].addActionListener(this);
			jpopcar[i].setActionCommand(car[i]);			
		}
		add(jpopcouper);
		add(jpopcopier);
		add(jpopcoller);
		jpopcouper.setActionCommand(MenuListener.EDIT_CUT);
		jpopcouper.addActionListener(this);
		jpopcoller.setActionCommand(MenuListener.EDIT_PASTE);
		jpopcoller.addActionListener(this);
		jpopcopier.setActionCommand(MenuListener.EDIT_COPY);
		jpopcopier.addActionListener(this);
		setText();
	}
	void setText(){
		jpopcoller.setText(Logo.messages.getString("coller"));
		jpopcouper.setText(Logo.messages.getString("couper"));
		jpopcopier.setText(Logo.messages.getString("copier"));
		// Si le langage choisie est l'esperanto, on rajoute les caractères accentués spéciaux au menu
		if (Config.langage==Config.LANGUAGE_ESPERANTO) {
			add(separ);
			for (int i=0;i<jpopcar.length;i++) {
				add(jpopcar[i]);
			}
		}
		else if(this.getComponentCount()>3){
			remove(separ);
			for (int i=0;i<jpopcar.length;i++) remove(jpopcar[i]);
		}
	}
	public void actionPerformed(ActionEvent e){
		String cmd=e.getActionCommand();
		if (cmd.equals(MenuListener.EDIT_COPY)) jt.copy();
		else if (cmd.equals(MenuListener.EDIT_CUT)) jt.cut();
		else if (cmd.equals(MenuListener.EDIT_PASTE)) jt.paste();
		else{
			for (int i=0;i<car.length;i++){
				if (car[i].equals(cmd)) {
					int pos=jt.getCaretPosition();
					try{
						String debut=jt.getText(0,pos);
						int longueur=jt.getText().length();
						String fin="";
						if (longueur>pos) fin=jt.getText(pos+1,longueur-pos);
						jt.setText(debut+car[i]+fin);
						jt.setCaretPosition(pos+1);
					}
					catch(BadLocationException e1){}
					break;
				}
			}	
		}
	} 
}
